#property indicator_separate_window //   
#property indicator_buffers 2
#property indicator_color1 Blue // 
#property indicator_color2 Red // 
#property indicator_maximum 100
#property indicator_minimum 0
#property indicator_level1 70
#property indicator_level2 30

//  
extern int RSImin=14; //  RSI 
extern int RSImax=33; // 
extern int Sens=3; //   .
   double sens; //   
extern int SignalMA=1; //  
   double ks; // . EMA 
   bool method=0; // 0 - SMA, 1 - EMA (SignalMA<0)
 int History=0; // 0-  

// .
double   Main[], //   
         Signal[]; //   


// 
void init()
  {
   sens=Sens*Point; //   
   // . EMA 
   if(SignalMA<0) {
      SignalMA=-SignalMA;
      ks=2.0/(1+SignalMA); // . EMA  
      method=1;
     }
   // .
   string _r="RSI("+RSImin+"-"+RSImax+","+SignalMA+")";
   SetIndexBuffer(0,Main); // 
   SetIndexStyle(0,DRAW_LINE,0);
   SetIndexLabel(0,_r);

   SetIndexBuffer(1,Signal); // 
   SetIndexStyle(1,DRAW_LINE);
   SetIndexLabel(1,"("+SignalMA+")");

   if(Sens!=0) string ShName=Sens+" ";
   IndicatorShortName(ShName+_r); 
  }

// -  
int reinit() 
  {
   ArrayInitialize(Main,0.0); //  
   ArrayInitialize(Signal,0.0); //  
   return(0);
  }

void start()
  {
   int ic=IndicatorCounted();
   if(Bars-ic-1>1) ic=reinit(); //    >1  - 
   int limit=Bars-ic-1; // - 
   if(History!=0 && limit>History) limit=History-1; // -   

   for(int i=limit; i>=0; i--) { //     
      //  
      int j,per;
      for(j=0,per=0; j<RSImax && per<RSImin; j++)
         if(High[i+j]-Low[i+j]>=sens) per++; //  TR
      per=MathMax(j-1,RSImin);
      // RSI
      Main[i]=iRSI(NULL,0,per,0, i);
      // 
      switch(method) {
         case 1: // EMA
            Signal[i]=ks*Main[i]+(1-ks)*Signal[i+1]; break;
         case 0: // SMA
            int sh=i+SignalMA;
            double ma=Signal[i+1]*SignalMA-Main[sh];
            Signal[i]=(ma+Main[i])/SignalMA;
        }
     }   
  }



